import argparse
import sys
import matplotlib.pyplot as plt

def main(argv):

    parser = argparse.ArgumentParser()


    parser.add_argument(
        "log_file",
        help = "path to log file"
        )

    args = parser.parse_args()

    f = open(args.log_file)

    lines  = [line.rstrip("\n") for line in f.readlines()]

    numbers = {'1','2','3','4','5','6','7','8','9'}

    iters = []
    loss = []
    mAP = []

    fig,ax = plt.subplots()

    for line in lines:
        args = line.lstrip().split(' ')
        if args[0][-1:]==':' and args[0][0] in numbers:
            iters.append(int(args[0][:-1]))
            loss.append(min(float(args[2]),250.0))
        if args[0]=='Last':
            mAP.append(float(args[4]))

    # make map and iters equal with zero padding
    if (len(iters) > len(mAP)):
        mAP = [0.0]*(len(iters) - len(mAP)) + mAP
    elif (len(iters) < len(mAP)):
        mAP = [0.0]*(len(mAP) - len(iters)) + mAP

    axM = ax.twinx()  # instantiate a second axes that shares the same x-axis

    ax.plot(iters,loss, 'b')
    ax.set_xlabel('iters')
    ax.set_ylabel('loss', color='b')

    axM.plot(iters,mAP, 'r')
    axM.set_xlabel('iters')
    axM.set_ylabel('mAP', color='r')

    plt.grid()

    ticks = range(0,250,10)

    fig.tight_layout()  # otherwise the right y-label is slightly clipped
    plt.savefig('loss_plot.jpg')

    #ax.set_yticks(ticks)
    #plt.show()

if __name__ == "__main__":
    main(sys.argv)
